Attribute VB_Name = "Utils"
' Author : Shirish K.
' Copyright Texas Instruments Austin Design Center
' Description: Utility functions for string to hex conversions and vice versa

Option Explicit
Option Base 0
'Returns a block of data and size in bytes
Public Function StrHexToHex(stext As String, ByRef Data() As Byte, ByRef nSize As Integer) As Boolean
Dim TotalLen As Integer
Dim sStrToConv As String
Dim Index As Integer
stext = Replace(stext, " ", "")
stext = Replace(stext, Chr(13), "")
stext = Replace(stext, Chr(10), "")
stext = Replace(stext, Chr(9), "")
TotalLen = Len(stext)
Index = 1
If (TotalLen Mod 2) > 0 Then
   StrHexToHex = False
   Exit Function
End If
While TotalLen > 0
   sStrToConv = "&h"
   sStrToConv = sStrToConv & Mid(stext, 1 + (Index - 1) * 2, 2)
   Data(Index - 1) = Val(sStrToConv)
   Index = Index + 1
   If Index > nSize Then
      StrHexToHex = False
   End If
   TotalLen = TotalLen - 2
Wend
If Index = 0 Then
   StrHexToHex = False
   Exit Function
End If
nSize = Index - 1
StrHexToHex = True
End Function

Public Function WordHexToHex(stext As String) As Integer
   WordHexToHex = Val("&h" & stext)
End Function

Public Function ByteHexToHex(stext As String) As Byte
   ByteHexToHex = Val("&h" & stext)
End Function

Sub DoDelay(fWaitTime As Single) ' In seconds
    Dim vTime As Variant
    vTime = Timer
    While Timer < (vTime + fWaitTime)
        'fix midnight problem
        If Timer < vTime Then Exit Sub
        
        'Comm events can't come in unless we yield to them here!
        DoEvents
    Wend
End Sub

Function IsCharHexType(sValue As String) As Boolean
Dim char As Integer
Dim sTmp As String
sTmp = sValue
sTmp = StrConv(sTmp, vbUpperCase)
char = Asc(sTmp)
If char < Asc("0") Then
   IsCharHexType = False
   Exit Function
End If
If char > Asc("F") Then
   IsCharHexType = False
   Exit Function
End If
If char > Asc("9") Then
   If char < Asc("A") Then
      IsCharHexType = False
   Exit Function
   End If
End If
IsCharHexType = True
End Function
Public Function HexValidate(sValue As String, Numdigits) As Boolean
Dim nLen As Integer
Dim sAdjValue As String
sAdjValue = Replace(sValue, " ", "")
sAdjValue = Replace(sAdjValue, Chr(9), "")
sAdjValue = Replace(sAdjValue, Chr(13), "")
sAdjValue = Replace(sAdjValue, Chr(10), "")
nLen = Len(sAdjValue)
While (nLen > 0)
   If IsCharHexType(Mid(sAdjValue, nLen, 1)) = False Then
      HexValidate = False
      Exit Function
   End If
   nLen = nLen - 1
Wend
HexValidate = True
End Function

Public Sub LongToWords(ByVal nLong As Long, ByRef MSW As Integer, ByRef LSW As Integer)
   Dim NegSign As Boolean
   NegSign = False
   If nLong < 0 Then
       nLong = nLong + 2147483648#
       NegSign = True
   End If
   MSW = nLong \ 32768
   LSW = nLong - MSW * 32768
   If NegSign Then
       MSW = MSW + &H8000
   End If
End Sub

Public Sub WordToBytes(ByVal nWord As Integer, ByRef msb As Byte, ByRef lsb As Byte)
   Dim NegSign As Boolean
   NegSign = False
   If nWord < 0 Then
       nWord = nWord + 32768
       NegSign = True
   End If
   msb = nWord \ 256
   lsb = nWord - msb * 256
   If NegSign Then
       msb = msb + &H80
   End If
End Sub
Public Sub BytesToWord(ByRef msb As Byte, ByRef lsb As Byte, ByRef nWord As Integer)
   If (msb > 127) Then
      nWord = (msb - 128) * 256 + &H8000 + lsb
   Else
      nWord = msb * 256 + lsb
   End If
End Sub
Public Sub WordsToLong(ByRef msb As Integer, ByRef lsb As Integer, ByRef nLong As Long)
Dim bLsbNeg As Boolean
Dim bMsbNeg As Boolean
   bLsbNeg = False
   bMsbNeg = False
   If (msb < 0) Then
      bMsbNeg = True
   End If
   If (lsb < 0) Then
      bLsbNeg = True
   End If
   If bMsbNeg Then
      msb = msb + 32768
   End If
   If bLsbNeg Then
      lsb = lsb + 32768
   End If
   nLong = msb * 65536 + lsb
   If bLsbNeg Then
      nLong = nLong + 32768  'Should be done before no. becomes neg
   End If
   If bMsbNeg Then
      nLong = nLong + &H80000000
   End If
End Sub

'Noise chars removed are CR,LF,Tab,space
Public Function RemoveNoiseChars(stxt As String) As String
Dim stext As String
stext = stxt   'Initialize
stext = Replace(stext, " ", "")
stext = Replace(stext, Chr(13), "")
stext = Replace(stext, Chr(10), "")
stext = Replace(stext, Chr(9), "")
RemoveNoiseChars = stext
End Function

